import poser
import math
import random
import os
# import aaposer4mancenters
def det3(A,B,C,D,E,F,G,H,I):
	return (A*(E*I-H*F)+D*(H*C-B*I)+G*(B*F-E*C))

def matinvert_4(aw,ax,ay,az,bw,bx,by,bz,cw,cx,cy,cz,dw,dx,dy,dz): # arg by rows
	AW= det3(               bx,by,bz,   cx,cy,cz,   dx,dy,dz)
	BW=-det3(            bw,   by,bz,cw,   cy,cz,dw,   dy,dz)
	CW= det3(            bw,bx,   bz,cw,cx,   cz,dw,dx,   dz)
	DW=-det3(            bw,bx,by,   cw,cx,cy,   dw,dx,dy   )
	det=AW*aw+BW*ax+CW*ay+DW*az
	if det==0: return None
	AW/=det; BW/=det; CW/=det; DW/=det
	AX=-det3(   ax,ay,az,               cx,cy,cz,   dx,dy,dz)/det
	BX= det3(aw,   ay,az,            cw,   cy,cz,dw,   dy,dz)/det
	CX=-det3(aw,ax,   az,            cw,cx,   cz,dw,dx,   dz)/det
	DX= det3(aw,ax,ay,               cw,cx,cy,   dw,dx,dy   )/det
	AY= det3(   ax,ay,az,   bx,by,bz,               dx,dy,dz)/det
	BY=-det3(aw,   ay,az,bw,   by,bz,            dw,   dy,dz)/det
	CY= det3(aw,ax,   az,bw,bx,   bz,            dw,dx,   dz)/det
	DY=-det3(aw,ax,ay,   bw,bx,by,               dw,dx,dy   )/det
	AZ=-det3(   ax,ay,az,   bx,by,bz,   cx,cy,cz            )/det
	BZ= det3(aw,   ay,az,bw,   by,bz,cw,   cy,cz            )/det
	CZ=-det3(aw,ax,   az,bw,bx,   bz,cw,cx,   cz            )/det
	DZ= det3(aw,ax,ay,   bw,bx,by,   cw,cx,cy               )/det
#	return [[AW,BW,CW,DW],[AX,BX,CX,DX],[AY,BY,CY,DY],[AZ,BZ,CZ,DZ]]
	return [[AW,AX,AY,AZ],[BW,BX,BY,BZ],[CW,CX,CY,CZ],[DW,DX,DY,DZ]]

def matinvert4(M):
	aw=M[0][0]; ax=M[0][1]; ay=M[0][2]; az=M[0][3]
	bw=M[1][0]; bx=M[1][1]; by=M[1][2]; bz=M[1][3]
	cw=M[2][0]; cx=M[2][1]; cy=M[2][2]; cz=M[2][3]
	dw=M[3][0]; dx=M[3][1]; dy=M[3][2]; dz=M[3][3]
	return matinvert_4(aw,ax,ay,az,bw,bx,by,bz,cw,cx,cy,cz,dw,dx,dy,dz)

def xworldmat(v,N):
	x=v[0]; y=v[1]; z=v[2]
	X=x*N[0][0]+y*N[1][0]+z*N[2][0]+N[3][0]
	Y=x*N[0][1]+y*N[1][1]+z*N[2][1]+N[3][1]
	Z=x*N[0][2]+y*N[1][2]+z*N[2][2]+N[3][2]
#	W=x*N[0][3]+y*N[1][3]+z*N[2][3]+N[3][3] # should = 1
	return [X,Y,Z]

def vec4(V): return [V[0],V[1],V[2],1.0]

def dist3d(a,b): return math.sqrt((a[0]-b[0])**2+(a[1]-b[1])**2+(a[2]-b[2])**2)

poser4mancenters=(\
(0,"BODY",0.0004,0.4668,-0.0077),\
(1,"hip",0,0.4086,-0.0135),\
(2,"abdomen",0.0004,0.4668,-0.0077),\
(3,"chest",-0.0010,0.5410,-0.0090),\
(4,"neck",0.0010,0.6500,-0.0220),\
(5,"head",0,0.6537,-0.0156),\
(4,"rCollar",-0.0400,0.5920,-0.0070),\
(5,"rShldr",-0.0840,0.6070,-0.0210),\
(6,"rForeArm",-0.1850,0.6110,-0.0320),\
(7,"rHand",-0.2950,0.6100,-0.0260),\
(8,"rThumb1",-0.3020,0.6040,-0.0160),\
(9,"rThumb2",-0.3120,0.5990,-0.0110),\
(10,"rThumb3",-0.3216,0.5939,-0.0104),\
(11," rThumb3",-0.3329,0.5886,-0.0104),\
(8,"rIndex1",-0.3260,0.6160,-0.0130),\
(9,"rIndex2",-0.3412,0.6132,-0.0123),\
(10,"rIndex3",-0.3509,0.6093,-0.0131),\
(11," rIndex3",-0.3579,0.6035,-0.0131),\
(8,"rMid1",-0.3280,0.6160,-0.0230),\
(9,"rMid2",-0.3440,0.6120,-0.0230),\
(10,"rMid3",-0.3515,0.6037,-0.0228),\
(11," rMid3",-0.3553,0.5940,-0.0220),\
(8,"rRing1",-0.3280,0.6140,-0.0330),\
(9,"rRing2",-0.3410,0.6090,-0.0320),\
(10,"rRing3",-0.3467,0.6007,-0.0309),\
(11," rRing3",-0.3492,0.5924,-0.0309),\
(8,"rPinky1",-0.3240,0.6090,-0.0410),\
(9,"rPinky2",-0.3342,0.6057,-0.0406),\
(10,"rPinky3",-0.3390,0.6000,-0.0400),\
(11," rPinky3",-0.3440,0.5934,-0.0395),\
(4,"lCollar",0.0400,0.5920,-0.0070),\
(5,"lShldr",0.0840,0.6070,-0.0210),\
(6,"lForeArm",0.1850,0.6110,-0.0320),\
(7,"lHand",0.2950,0.6100,-0.0260),\
(8,"lThumb1",0.3020,0.6040,-0.0160),\
(9,"lThumb2",0.3120,0.5990,-0.0110),\
(10,"lThumb3",0.3216,0.5939,-0.0104),\
(11," lThumb3",0.3329,0.5886,-0.0104),\
(8,"lIndex1",0.3260,0.6160,-0.0130),\
(9,"lIndex2",0.3412,0.6132,-0.0123),\
(10,"lIndex3",0.3509,0.6093,-0.0131),\
(11," lIndex3",0.3579,0.6035,-0.0131),\
(8,"lMid1",0.3280,0.6160,-0.0230),\
(9,"lMid2",0.3440,0.6120,-0.0230),\
(10,"lMid3",0.3515,0.6037,-0.0228),\
(11," lMid3",0.3553,0.5940,-0.0220),\
(8,"lRing1",0.3280,0.6140,-0.0330),\
(9,"lRing2",0.3410,0.6090,-0.0320),\
(10,"lRing3",0.3467,0.6007,-0.0309),\
(11," lRing3",0.3492,0.5924,-0.0309),\
(8,"lPinky1",0.3240,0.6090,-0.0410),\
(9,"lPinky2",0.3342,0.6057,-0.0406),\
(10,"lPinky3",0.3390,0.6000,-0.0400),\
(11," lPinky3",0.3440,0.5934,-0.0395),\
(2,"rThigh",-0.0400,0.4160,-0.0100),\
(3,"rShin",-0.0445,0.2026,-0.0100),\
(4,"rFoot",-0.0451,0.0410,-0.0107),\
(5,"rToe",-0.0504,0.0122,0.0415),\
(6," rToe",-0.0504,0.0093,0.0724),\
(2,"lThigh",0.0400,0.4160,-0.0100),\
(3,"lShin",0.0445,0.2026,-0.0100),\
(4,"lFoot",0.0451,0.0410,-0.0107),\
(5,"lToe",0.0504,0.0114,0.0403),\
(6," lToe",0.0504,0.0093,0.0724))

def findactor(fig,fn):
	if fig==None:
		return None
	acts1=fig.Actors()
	for ac1 in acts1:
		if ac1.InternalName().startswith(fn):
			return ac1
	return None

def par(ac,pn):
	p=ac.ParameterByCode(pn)
	if p==None:
		return 999
	else:
		return p.Value()

def spar(ac,pn,v):
	p=ac.ParameterByCode(pn)
	if (p!=None) and (v!=999):
		p.SetValue(v)

def paradd(ac,pn,dv):
	p=ac.ParameterByCode(pn)
	if p!=None:
		p.SetValue(p.Value()+dv)

def posea(ac,xr,yr,zr,xt,yt,zt):
	if ac!=None:
		spar(ac,1,xr); spar(ac,2,yr); spar(ac,3,zr)
		spar(ac,4,xt); spar(ac,5,yt); spar(ac,6,zt)

def poseas(ac,xr,yr,zr,xt,yt,zt,xs,ys,zs,s):
	if ac!=None:
		spar(ac,1,xr); spar(ac,2,yr); spar(ac,3,zr)
		spar(ac,4,xt); spar(ac,5,yt); spar(ac,6,zt)
		spar(ac,7,xs); spar(ac,8,ys); spar(ac,9,zs); spar(ac,10,s)

def pose(fig,acn,xr,yr,zr,xt,yt,zt):
	ac=findactor(fig,acn+':')
	if ac!=None:
		spar(ac,1,xr); spar(ac,2,yr); spar(ac,3,zr)
		spar(ac,4,xt); spar(ac,5,yt); spar(ac,6,zt)

def poseadda(ac,xr,yr,zr,xt,yt,zt):
	if ac!=None:
		paradd(ac,1,xr); paradd(ac,2,yr); paradd(ac,3,zr)
		paradd(ac,4,xt); paradd(ac,5,yt); paradd(ac,6,zt)

def poseadd(fig,acn,xr,yr,zr,xt,yt,zt):
	poseadda(fig.ActorByInternalName(acn),xr,yr,zr,xt,yt,zt)

def poses(fig,acn,xr,yr,zr,xt,yt,zt,xs,ys,zs,s):
	ac=fig.ActorByInternalName(acn)
	if ac!=None:
		spar(ac,1,xr); spar(ac,2,yr); spar(ac,3,zr)
		spar(ac,4,xt); spar(ac,5,yt); spar(ac,6,zt)
		spar(ac,7,xs); spar(ac,8,ys); spar(ac,9,zs); spar(ac,10,s)

def dpose(fig,d,acn,xr,yr,zr,xt,yt,zt):
	ac=fig.ActorByInternalName(acn)
	if ac!=None:
		spar(ac,1,xr); spar(ac,2,yr);	spar(ac,3,zr)
		spar(ac,4,xt+d[0]); spar(ac,5,yt+d[1]); spar(ac,6,zt+d[2])

def dposea(d,ac,xr,yr,zr,xt,yt,zt):
	if ac!=None:
		spar(ac,1,xr); spar(ac,2,yr);	spar(ac,3,zr)
		spar(ac,4,xt+d[0]); spar(ac,5,yt+d[1]); spar(ac,6,zt+d[2])

def findIKlimbs(fig):
	iks=fig.IkNames(); nik=fig.NumIkChains(); la=ra=ll=rl=-1;
	while nik>0:
		nik-=1; n=iks[nik]
		if (n.find("arm")>=0) or (n.find("Arm")>=0) or(n.find("hand")>=0) or (n.find("hand")>=0):
			if (n[0]=='L') or (n[0]=='l'): la=nik
			if (n[0]=='R') or (n[0]=='r'): ra=nik
		if (n.find("leg")>=0) or (n.find("leg")>=0) or(n.find("foot")>=0) or (n.find("Foot")>=0):
			if (n[0]=='L') or (n[0]=='l'): la=nik
			if (n[0]=='R') or (n[0]=='r'): ra=nik
	return (la,ra,ll,rl)

def armsIKon(fig,lr=3):
	iks=fig.IkNames(); nik=fig.NumIkChains()
	while nik>0:
		nik=nik-1; n=iks[nik]
		if (n.find("arm")>=0) or (n.find("Arm")>=0) or (n.find("hand")>=0) or (n.find("Hand")>=0):
			if(((lr & 1) and ((n[0]=='l') or (n[0]=='L'))) or ((lr & 2) and ((n[0]=='r') or (n[0]=='R')))):
				fig.SetIkStatus(nik,1)

def armsIKoff(fig,lr=3):
	iks=fig.IkNames(); nik=fig.NumIkChains()
	while nik>0:
		nik-=1; n=iks[nik]
		if (n.find("arm")>=0) or (n.find("Arm")>=0) or (n.find("hand")>=0) or (n.find("Hand")>=0):
			if(((lr & 1) and ((n[0]=='l') or (n[0]=='L'))) or ((lr & 2) and ((n[0]=='r') or (n[0]=='R')))):
				fig.SetIkStatus(nik,0)

def legsIKoff(fig,lr=3):
	iks=fig.IkNames(); nik=fig.NumIkChains()
	while nik>0:
		nik-=1; n=iks[nik]
		if (n.find("leg")>=0) or (n.find("Leg")>=0) or (n.find("foot")>=0) or (n.find("Foot")>=0):
			if(((lr & 1) and ((n[0]=='l') or (n[0]=='L'))) or ((lr & 2) and ((n[0]=='r') or (n[0]=='R')))):
				fig.SetIkStatus(nik,0)

def fnincludes(name,seg):
	ns=name.split("\\"); b=False
	for n in ns:
		if n==seg:
			b=True; break
	return b

def findroot(act,findman=False):
	while True:
		fig=act.ItsFigure()
		if fig==None:
			print "I am at a ",act.Name() # not figure, so go to its parent
			a=act.Parent()
			if (not findman) and (a.InternalName()=="UNIVERSE"): return act
			if a==None: return None
			else: act=a; print "not figure or prop: go to parent: ",; continue
		f=fig.ConformTarget()
		if f!=None:
			fig=f
			act=fig.ParentActor(); print "conformer: go to conformee: ",
		print "I am at ",fig.Name(),"'s ",act.Name()
		head=findactor(fig,"head")
		if findman and (head!=None):
			return fig # found a character with a head: assume that it is a human
		a=fig.ParentActor().Parent()
		if (not findman) and (a.InternalName()=="UNIVERSE"): return act
		act=a; print "go to parent: ",

def findman(act):
	return findroot(act,True)

def correctforchar(fig,move=3): # move: 1 = left, 2 = right, additive 
	scn = poser.Scene()
	ac=scn.CurrentActor()
	pi=4*math.atan(1); deg=180/pi
	handslopes_dk=(
	(0.0000, 26.4735, 23.3500, 29.7070),\
	(0.0000, 0.0000, 20.1000, 40.0781),\
	(0.0000, 9.3000, 44.1000, 68.4776),\
	(0.0000, 8.8000, 56.0500, 69.4336),\
	(0.0000, 11.8000, 44.1000, 69.4336),\
	(0.0000, -26.4735, -23.3500, -29.7070),\
	(0.0000, 0.0000, -20.1000, -40.0781),\
	(0.0000, -9.3000, -44.1000, -68.4776),\
	(0.0000, -8.8000, -56.0500, -69.4336),\
	(0.0000, -11.8000, -44.1000, -51.8555))

	f0=("rHand","rThumb1","rThumb2","rThumb3"," rThumb3")
	f1=("rHand","rIndex1","rIndex2","rIndex3"," rIndex3")
	f2=("rHand","rMid1","rMid2","rMid3"," rMid3")
	f3=("rHand","rRing1","rRing2","rRing3"," rRing3")
	f4=("rHand","rPinky1","rPinky2","rRing3"," rRing3")
	f5=("lHand","lThumb1","lThumb2","lThumb3"," lThumb3")
	f6=("lHand","lIndex1","lIndex2","lIndex3"," lIndex3")
	f7=("lHand","lMid1","lMid2","lMid3"," lMid3")
	f8=("lHand","lRing1","lRing2","lRing3"," lRing3")
	f9=("lHand","lPinky1","lPinky2","lPinky3"," lPinky3")
	jnames=(f0,f1,f2,f3,f4,f5,f6,f7,f8,f9)
	handcoords_dk=[[[0.0]*3 for i in xrange(5)] for j in xrange(10)]
	handcoords=[[[0.0]*3 for i in xrange(5)] for j in xrange(10)]
	handslopes=[[0.0]*4 for j in xrange(10)]
	handslopes_dk=[[0.0]*4 for j in xrange(10)]
	handangles=[[0.0]*4 for j in xrange(10)]
	handangles_dk=[[0.0]*4 for j in xrange(10)]
	acts=[[ac]*4 for j in xrange(10)] # for finger joint actors
	elbowcoordR_dk=(-0.1850,0.6110,-0.0320)
	elbowcoordL_dk=(0.1850,0.6110,-0.0320)
	elbowcoordR=findactor(fig,"rForeArm").Origin()
	elbowcoordL=findactor(fig,"lForeArm").Origin()

	for i in (0,1,2,3,4,5,6,7,8,9):
		for j in (0,1,2,3): # for each finger joint
			ac=findactor(fig,jnames[i][j]); acts[i][j]=ac; k=0 # look for a finger joint actor
			if ac!=None: handcoords[i][j]=ac.Origin() # coords of each joint
			else: print "I can't find the origin of ",jnames[i][j]
			for p in poser4mancenters:
				if ac.InternalName().split(':')[0]==p[1]:
					handcoords_dk[i][j]=(p[2],p[3],p[4]); k=1; break; # finger joint coords for Poser 4 man
			if k==0: print "### I can't find ",jnames[i][j]," in _dk"
		if ac!=None: handcoords[i][4]=ac.EndPoint() # coords of fingertips

		for j in (0,1,2,3): handslopes[i][j]=math.atan2(handcoords[i][j+1][1]-handcoords[i][j][1],handcoords[i][j+1][0]-handcoords[i][j][0])
	 	handangles[i][0]=handslopes[i][0] # -handslopes[i][-1]
	 	for j in (1,2,3): handangles[i][j]=handslopes[i][j]-handslopes[i][j-1]
		for j in (0,1,2,3): handslopes_dk[i][j]=math.atan2(handcoords_dk[i][j+1][1]-handcoords_dk[i][j][1],handcoords_dk[i][j+1][0]-handcoords_dk[i][j][0])
	 	handangles_dk[i][0]=handslopes_dk[i][0] # -handslopes_dk[i][-1]
	 	for j in (1,2,3): handangles_dk[i][j]=handslopes_dk[i][j]-handslopes_dk[i][j-1]
	print "applying angle corrections to finger joint bends"
	forearm_yrot_R_dk=math.atan2(handcoords_dk[0][0][2]-elbowcoordR_dk[2],handcoords_dk[0][0][0]-elbowcoordR_dk[0])
 	forearm_yrot_L_dk=math.atan2(handcoords_dk[5][0][2]-elbowcoordL_dk[2],handcoords_dk[5][0][0]-elbowcoordL_dk[0])
	forearm_yrot_R=math.atan2(handcoords[0][0][2]-elbowcoordR[2],handcoords[0][0][0]-elbowcoordR[0])
	forearm_yrot_L=math.atan2(handcoords[5][0][2]-elbowcoordL[2],handcoords[5][0][0]-elbowcoordL[0])
	forearm_zrot_R_dk=math.atan2(handcoords_dk[0][0][1]-elbowcoordR_dk[2],handcoords_dk[0][0][0]-elbowcoordR_dk[0])
 	forearm_zrot_L_dk=math.atan2(handcoords_dk[5][0][1]-elbowcoordL_dk[2],handcoords_dk[5][0][0]-elbowcoordL_dk[0])
	forearm_zrot_R=math.atan2(handcoords[0][0][1]-elbowcoordR[2],handcoords[0][0][0]-elbowcoordR[0])
	forearm_zrot_L=math.atan2(handcoords[5][0][1]-elbowcoordL[2],handcoords[5][0][0]-elbowcoordL[0])
	if(move&2):
		for i in (0,1,2,3,4):
			for j in (1,2,3):
				ac=acts[i][j]
				if(ac!=None):
					par=ac.ParameterByCode(3); par.SetValue(par.Value()+(handangles_dk[i][j]-handangles[i][j]))
	i=2
	ac=acts[i][0]
	if(ac!=None):
		par=ac.ParameterByCode(3); par.SetValue(par.Value()+(handangles_dk[i][0]-handangles[i][0])) # 3 = zrot
	if(move&1):
		for i in (5,6,7,8,9):
			for j in (1,2,3):
				ac=acts[i][j]
				if(ac!=None):
					par=ac.ParameterByCode(3); par.SetValue(par.Value()+(handangles_dk[i][j]-handangles[i][j]))
	i=7
	ac=acts[i][0]
	if(ac!=None):
		par=ac.ParameterByCode(3); par.SetValue(par.Value()+(handangles_dk[i][0]-handangles[i][0])) # 3 = zrot

	lhand = findactor(fig,"lHand")
	if lhand!=None:
		lhc=lhand.Origin(); ld=( 0.295-lhc[0],0.610-lhc[1],-0.026-lhc[2])
		if(move & 1): poseadd(fig,"lHand",0,0,0,ld[0],ld[1],ld[2])
		if(move & 1): armsIKoff(fig,1)
		dlh=(0,forearm_yrot_L_dk-forearm_yrot_L,-(forearm_zrot_L_dk-forearm_zrot_L),ld[0],ld[1],ld[2]) ##############
		if(move & 1): armsIKon(fig,1)
	else: dlh=(None,None,None,None,None,None)
	rhand = findactor(fig,"rHand")
	if rhand!=None:
		rhc=rhand.Origin(); rd=(-0.295-rhc[0],0.610-rhc[1],-0.026-rhc[2]);
		if(move & 2): poseadd(fig,"rHand",0,0,0,rd[0],rd[1],rd[2])
		if(move & 2): armsIKoff(fig,2)
		drh=(0,forearm_yrot_R_dk-forearm_yrot_R,-(forearm_zrot_R_dk-forearm_zrot_R),rd[0],rd[1],rd[2])###
		if(move & 2): armsIKon(fig,2)
	else: drh=(None,None,None,None,None,None)
	return (dlh,drh) # corrections to xRotate yRotate zRotate xTran yTran zTran, left hand then right hand

def correctforchar2(fig):
	rhand = findactor(fig,"rHand")
	if rhand!=None:
		rhc=rhand.Origin(); rd=(-0.295-rhc[0],0.610-rhc[1],-0.026-rhc[2]); poseadd(fig,"rHand",0,0,0,rd[0],rd[1],rd[2])
	lhand = findactor(fig,"lHand")
	if lhand!=None:
		lhc=lhand.Origin(); ld=( 0.295-lhc[0],0.610-lhc[1],-0.026-rhc[2]); poseadd(fig,"lHand",0,0,0,ld[0],ld[1],ld[2])

def hidepart(fig,pn):
	part=findactor(fig,pn)
	if part!=None:
		part.SetCastsShadows(0); part.SetOnOff(0)

def showpart(fig,pn):
	part=findactor(fig,pn)
	if part!=None:
		part.SetCastsShadows(1); part.SetOnOff(1)

def ask(prompt):
	parentDialog = 1; dialog = poser.DialogTextEntry(parentDialog,prompt); dialog.Show(); return dialog.Text()

def fileexists(file):
	libs = poser.Libraries()
	for lib in libs:
		if os.path.exists(lib+file):
			print lib+file," exists"; return True
	return False

def loadprop(file):
	scn = poser.Scene()
	acs1=scn.Actors(); scn.LoadLibraryProp(file); acs2=scn.Actors()
	for a in acs2:
		c=a
		for b in acs1:
			if b.Name()==a.Name(): c=None; break
		if c != None:
			return findroot(a)
	return None

def load_fig(file):
	scn = poser.Scene()
	acs1=scn.Figures(); scn.LoadLibraryFigure(file); acs2=scn.Figures()
	for a in acs2:
		c=a
		for b in acs1:
			if b.Name()==a.Name(): c=None; break
		if c != None:
			return a
	return None

def loadfigure(file):
	fig=findroot(load_fig(file).ParentActor(),False).ItsFigure()
	legsIKoff(fig)
	return fig

def loadfig(file,par,x,y,z,X,Y,Z):
	fig=loadfigure(file)
	body=fig.ParentActor()
	body.SetParent(par)
	posea(body,x,y,z,X,Y,Z)
	return fig

def vert(v): return [v.X(),v.Y(),v.Z()] 

def linethrutriangle(A,B,C,P,R): # line P-R intersecting plane of triangle A-B-C-A
	Ax=A[0]; Bx=B[0]; Cx=C[0]; Px=P[0]; Rx=R[0]
	Ay=A[1]; By=B[1]; Cy=C[1]; Py=P[1]; Ry=R[1]
	Az=A[2]; Bz=B[2]; Cz=C[2]; Pz=P[2]; Rz=R[2]
	det=det3(Ax-Cx,Bx-Cx,Rx-Px, Ay-Cy,By-Cy,Ry-Py, Az-Cz,Bz-Cz,Rz-Pz)
	atp=det3(Rx-Cx,Bx-Cx,Rx-Px, Ry-Cy,By-Cy,Ry-Py, Rz-Cz,Bz-Cz,Rz-Pz)
	btp=det3(Ax-Cx,Rx-Cx,Rx-Px, Ay-Cy,Ry-Cy,Ry-Py, Az-Cz,Rz-Cz,Rz-Pz)
	rtp=det3(Ax-Cx,Bx-Cx,Rx-Cx, Ay-Cy,By-Cy,Ry-Cy, Az-Cz,Bz-Cz,Rz-Cz)
#	if det==0: return None
	if det**2<1e-16: return None
	a=atp/det; b=btp/det; c=1-a-b; r=rtp/det; s=1-r
	thru=(a>=-1e-6) and (b>=-1e-6) and (c>=-1e-6)
	return [thru,[r*Px+s*Rx,r*Py+s*Ry,r*Pz+s*Rz],a,b,c,r,s]

def gunfire(beamb,beamf,ddist,rwm,ray):
	scn = poser.Scene(); n=0
	rayb=xworldmat(beamb,rwm); rayf=xworldmat(beamf,rwm) 
	hit=[False,[.0,.0,.0],.0,.0,.0,.0,.0,.0,.0,.0]; distance=1e80; achit=None; polhit=None
	for ac in scn.Actors():
		hits=0
		if (not ac.IsBodyPart()) and (not ac.IsProp()): continue
		if ac.VisibleInRender()!=1: continue
		if ac.InternalName()=="FocusDistanceControl": continue
		if ac.IsBase() or ac.IsCamera() or ac.IsDeformer() or ac.IsLight() or ac.IsZone() or (ac.Name()==ray.Name()): continue
		wm=ac.WorldMatrix()
		if wm==None: continue
		geom=ac.Geometry()
		if geom==None: continue;
		np=geom.NumPolygons
		for pol in geom.Polygons():
			vv=pol.Vertices(); n+=1; nv=pol.NumVertices(); j=-1
			vvm=[0.0]*nv
			while True:
				j+=1;
				if j>=nv: break
				vvm[j]=xworldmat(vert(vv[j]),wm)
			j=1;
			while True:
				j+=1
				if j>=nv: break
				v0=vvm[0]; v1=vvm[j-1]; v2=vvm[j]
				ltt=linethrutriangle(v0,v1,v2,rayb,rayf)
				if ltt==None: continue
				if ltt[0]:
					dist=dist3d(rayb,ltt[1])
					if ltt[5]>0: dist=-dist
					dist-=ddist
					if dist<0: continue
					if distance>dist: hit[0:6]=ltt; distance=dist; polhit=pol; achit=ac
	if hit[0]:
		print "hit on",
		f=achit.ItsFigure()
		if f!=None: print f.Name(),"'s",
		print achit.Name(),"(",polhit.MaterialName(),")",
		print ", distance =",distance,"(= ",distance/.12,"feet)"; distance+=.078484
	else: print "missed"; distance=10
	print "I checked",n,"polygons"
	hit[7]=distance; hit[8]=polhit; hit[9]=achit; return hit
